﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.IO;
using Microsoft.VisualBasic.FileIO;

public partial class ReadFile : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    //create string variables
    public static string inputFilePath;
    public static string DuplicateFilePath;
    public static string AddressFilePath;

    protected void CreateFiles_Click(object sender, EventArgs e)
    {
        //assign filepath values  
        inputFilePath = txtinputFilePath.Text;
        DuplicateFilePath = txtDuplicateFilePath.Text;
        AddressFilePath = txtAddressFilePath.Text;
        GetCSVData(inputFilePath);
        //message to display
        lblMessage.Text = "<b>The following output files were created:</b> <br/>"
                               + DuplicateFilePath + "<br/>" + AddressFilePath;
    }
    public DataTable GetCSVData(string csv_file_path)
    {

        DataTable csvData = new DataTable();

        try
        {
            //read text file
            using (TextFieldParser csvReader = new TextFieldParser(csv_file_path))
            {
                csvReader.SetDelimiters(new string[] { "," });
                csvReader.HasFieldsEnclosedInQuotes = true;
                string[] colFields = csvReader.ReadFields();

                foreach (string column in colFields)
                {
                    DataColumn datacolumn = new DataColumn(column);
                    datacolumn.AllowDBNull = true;
                    csvData.Columns.Add(datacolumn);
                }

                while (!csvReader.EndOfData)
                {
                    string[] fieldData = csvReader.ReadFields();
                    //Making empty value as null
                    for (int i = 0; i < fieldData.Length; i++)
                    {
                        if (fieldData[i] == "")
                        {
                            fieldData[i] = null;
                        }
                    }
                    //Fill datatable with data from csv file 
                    csvData.Rows.Add(fieldData);
                    //Run linq query get duplicate data and order by count 
                    var duplicateQuery = csvData.AsEnumerable().GroupBy(r => new
                    {
                        Lastname = r.Field<string>("LastName")

                    }).Select(grp => new
                    {
                        Lastname = grp.Key.Lastname,
                        count = grp.Count()
                    }).OrderByDescending(grp => grp.count);

                    //write duplicate data to an output text file
                    using (StreamWriter writer = new StreamWriter(DuplicateFilePath))
                        foreach (var data in duplicateQuery)
                        {
                            writer.WriteLine(data.Lastname + "," + data.count + ",");

                        }
                    //Run linq query to get address and order by address using first alphabet after address number  
                    var AddressQuery = csvData.AsEnumerable().GroupBy(r => new
                    {
                        Address = r.Field<string>("Address")

                    }).Select(grp => new
                    {
                        address = grp.Key.Address,
                    }).OrderBy(grp => grp.address.ToString().Split(' ')[1]);

                    //Write adress data to an ouput text file 
                    using (StreamWriter writer = new StreamWriter(AddressFilePath))

                        foreach (var data in AddressQuery)
                        {
                            writer.WriteLine(data.address);

                        }

                }
            }

        }
        catch (Exception)
        {
        }
        //Return datatable if necessary to bind to other objects
        return csvData;


    }
}